//Refcounted_ObjectKey.cpp,v 1.3 2003/08/02 01:10:45 bala Exp
#include "Refcounted_ObjectKey.h"
#include "ace/Log_Msg.h"

#if !defined (__ACE_INLINE__)
#include "Refcounted_ObjectKey.inl"
#endif /* defined INLINE */

ACE_RCSID(tao,
          Refcounted_ObjectKey,
          "Refcounted_ObjectKey.cpp,v 1.3 2003/08/02 01:10:45 bala Exp")


TAO::Refcounted_ObjectKey::Refcounted_ObjectKey (const TAO::ObjectKey &key)
  : object_key_ (key)
  , ref_count_ (1)
{
}


TAO::Refcounted_ObjectKey::~Refcounted_ObjectKey (void)
{
}

long
TAO::Refcounted_ObjectKey::decr_refcount (void)
{
  if (--this->ref_count_ > 0)
    return this->ref_count_;

  ACE_ASSERT (this->ref_count_ == 0);

  delete this;

  return 0;
}
